#!/bin/bash
###########################################################################
#   Copyright (C) 2005 by Harald Sitter                                   #
#   harald.sitter@kdemail.net                                             #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
###########################################################################
##
## KSIE 1.0.x install script
##
# define some constants/variables
#
KPREFIX=`kde-config --prefix`
PATHUS="${KPREFIX}/share/services/searchproviders"
CMD="cp -rf * ${PATHUS}"
ICON="konqueror"
R00T=""
#
#
#######################################################################################################################
# check if we are root and exit if we are
#
if [ "${USER}" = "root" ]; then
	kdialog --icon "${ICON}" --msgbox "Please don't run the script as root!"
	exit 1
elif [ "`echo ~`" = "/root" ]; then
	kdialog --icon "${ICON}" --msgbox "Please don't run the script as root!"
	exit 1
else
#
# start progressbar
#
PROGRESS=`kdialog --title "Installation" --icon ${ICON} --progressbar "Installing" 4`
#
# check whether kdesu is available, else use sudo or stop execution
#
dcop ${PROGRESS} setProgress 1 && dcop ${PROGRESS} setLabel "Determinate SU mode."
	if [ "`which kdesu`" = "" ]; then
		echo
		echo "KDESU (which is needed for this script) is not installed, or kde's bin isn't in your \$PATH variable"
		echo
			if [ "`which sudo`" = "" ]; then
				echo
				echo "Neither is SUDO available, the script can't be executed on this machine"
				echo
				dcop ${PROGRESS} close
				exit 1
			else
				R00T="sudo"
				ECO="sudo"
				echo
				echo "kdesu is not available, using sudo instead"
				echo
			fi
	else
		R00T="kdesu --icon "${ICON}" -t -d -c"
		ECO="kdesu"
	fi
fi
dcop ${PROGRESS} setLabel "Using "${ECO}"."
#
#
#######################################################################################################################
# use sudo or kdesu to install the files
#
dcop ${PROGRESS} setProgress 2 && dcop ${PROGRESS} setLabel "Installation."
	cd searchproviders
	${R00T} ${CMD}
	#check if user pressed ignore
		if [ "${R00T}" = "kdesu" ]; then
			while [ "$?" = "1" ]; do
				kdialog --msgbox "You have to enter the root password"
				${R00T} "${CMD}"
			done
		fi
dcop ${PROGRESS} setLabel "New files written."
#
#
#######################################################################################################################
# run kbuildsycoca
#
dcop ${PROGRESS} setProgress 3 && dcop ${PROGRESS} setLabel "Rebuild Caches."
	kbuildsycoca > /dev/null
dcop ${PROGRESS} setLabel "Caches rebuilt."
#
#
#######################################################################################################################
# just notifications and end of progressbar
#
dcop ${PROGRESS} setProgress 4 && dcop ${PROGRESS} setLabel "Installation Finished."
	if [ "${R00T}" = "kdesu" ]; then
		kdialog --icon "${ICON}" --msgbox "Installation finished"
	fi
dcop ${PROGRESS} close
#
#
#######################################################################################################################
exit 0